package ru.dbotthepony.mc.otm.datagen.textures

import net.neoforged.neoforge.common.data.SpriteSourceProvider
import net.neoforged.neoforge.data.event.GatherDataEvent
import ru.dbotthepony.mc.otm.client.render.ColorizedSpriteSource
import ru.dbotthepony.mc.otm.datagen.DataGen
import ru.dbotthepony.mc.otm.datagen.modLocation

class ColorizedSpritesProvider(event: GatherDataEvent) : SpriteSourceProvider(event.generator.packOutput, event.lookupProvider, DataGen.MOD_ID, event.existingFileHelper) {
	override fun gather() {
		listOf(
			"block/android_charger",
			"block/android_station_base",
			"block/batterybank_frame",
			"block/chemical_generator",
			"block/cobblestone_generator",
			"block/decorative/computer_base",
			"block/decorative/computer_screen",
			"block/drive_viewer",
			"block/electric_furnace",
			"block/electric_furnace_offline",
			"block/energy_counter",
			"block/energy_servo",
			"block/essence_storage",
			"block/induction_furnace",
			"block/induction_furnace_offline",
			"block/item_monitor",
			"block/matter_bottler",
			"block/matter_decomposer",
			"block/matter_panel",
			"block/matter_reconstructor",
			"block/matter_recycler",
			"block/matter_replicator_base",
			"block/matter_replicator_halted",
			"block/matter_replicator",
			"block/matter_replicator_offline",
			"block/matter_scanner",
			"block/mattercapacitorbank_frame",
			"block/plate_press",
			"block/plate_press2",
			"block/powered_smoker_base",
			"block/powered_smoker_interior_0",
			"block/powered_smoker_interior_1",
			"block/powered_smoker_interior_2",
			"block/decorative/star_chair",
			"block/storage_power_supplier",
			"block/water_source"
		).forEach {
			atlas(BLOCKS_ATLAS).addSource(
				ColorizedSpriteSource(modLocation(it), modLocation(it).withSuffix("_mask"), modLocation(it)).trackGeneratedTextures(existingFileHelper)
			)
		}

		atlas(BLOCKS_ATLAS).addSource(
			ColorizedSpriteSource(
				modLocation("block/decorative/tritanium_striped_block_colorless_base"),
				modLocation("block/decorative/tritanium_striped_block_colorless_stripe"),
				modLocation("block/decorative/stripe/tritanium_striped_block"),
				"_", true, true
			).trackGeneratedTextures(existingFileHelper)
		)
	}
}
